scripts/kernel_bump: Improve omitted version error
[openwrt/staging/stintel.git] / scripts / kernel_bump.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0-or-later
3 #
4 # Copyright (C) 2024 Olliver Schinagl <oliver@schinagl.nl>
5
6 set -eu
7 if [ -n "${DEBUG_TRACE_SH:-}" ] && \
8 [ "${DEBUG_TRACE_SH:-}" != "${DEBUG_TRACE_SH#*"$(basename "${0}")"*}" ] || \
9 [ "${DEBUG_TRACE_SH:-}" = 'all' ]; then
10 set -x
11 fi
12
13 REQUIRED_COMMANDS='
14 [
15 basename
16 command
17 echo
18 exit
19 git
20 printf
21 set
22 shift
23 '
24
25 _msg()
26 {
27 _level="${1:?Missing argument to function}"
28 shift
29
30 if [ "${#}" -le 0 ]; then
31 echo "${_level}: No content for this message ..."
32 return
33 fi
34
35 echo "${_level}: ${*}"
36 }
37
38 e_err()
39 {
40 _msg 'err' "${*}" >&2
41 }
42
43 e_warn()
44 {
45 _msg 'warning' "${*}"
46 }
47
48 e_notice()
49 {
50 _msg 'notice' "${*}"
51 }
52
53 usage()
54 {
55 echo "Usage: ${0}"
56 echo 'Helper script to bump the target kernel version, whilst keeping history.'
57 echo " -p Optional Platform name (e.g. 'ath79' [PLATFORM_NAME]"
58 echo " -s Source version of kernel (e.g. 'v6.1' [SOURCE_VERSION])"
59 echo " -t Target version of kernel (e.g. 'v6.6' [TARGET_VERSION]')"
60 echo
61 echo 'All options can also be passed in environment variables (listed between [BRACKETS]).'
62 echo 'Example: scripts/kernel_bump.sh -p realtek -s v6.1 -t v6.6'
63 }
64
65 cleanup()
66 {
67 trap - EXIT HUP INT QUIT ABRT ALRM TERM
68
69 if [ -n "${initial_branch:-}" ] && \
70 [ "$(git rev-parse --abbrev-ref HEAD)" != "${initial_branch:-}" ]; then
71 git switch "${initial_branch}"
72 fi
73 }
74
75 init()
76 {
77 initial_branch="$(git rev-parse --abbrev-ref HEAD)"
78 initial_commitish="$(git rev-parse HEAD)"
79
80 source_version="${source_version#v}"
81 target_version="${target_version#v}"
82
83 trap cleanup EXIT HUP INT QUIT ABRT ALRM TERM
84 }
85
86 bump_kernel()
87 {
88 platform_name="${platform_name##*'/'}"
89
90 if [ -z "${platform_name:-}" ]; then
91 platform_name="${PWD##*'/'}"
92 fi
93
94 if [ "${PWD##*'/'}" = "${platform_name}" ]; then
95 _target_dir='./'
96 else
97 _target_dir="target/linux/${platform_name}"
98 fi
99
100 if [ ! -d "${_target_dir}/image" ]; then
101 e_err 'Cannot find target linux directory.'
102 exit 1
103 fi
104
105 git switch --force-create '__openwrt_kernel_files_mover'
106
107 for _path in "${_target_dir}/"*; do
108 if [ ! -s "${_path}" ] || \
109 [ "${_path}" = "${_path%%"-${source_version}"}" ]; then
110 continue
111 fi
112
113 _target_path="${_path%%"-${source_version}"}-${target_version}"
114 if [ -s "${_target_path}" ]; then
115 e_err "Target '${_target_path}' already exists!"
116 exit 1
117 fi
118
119 git mv \
120 "${_path}" \
121 "${_target_path}"
122 done
123
124 find "${_target_dir}" -iname "config-${source_version}" | while read -r _config; do
125 _path="${_config%%"/config-${source_version}"}"
126 git mv "${_config}" "${_path}/config-${target_version}"
127 done
128
129 git commit \
130 --signoff \
131 --message "kernel/${platform_name}: Create kernel files for v${target_version} (from v${source_version})" \
132 --message 'This is an automatically generated commit.' \
133 --message 'When doing `git bisect`, consider `git bisect --skip`.'
134
135 git checkout 'HEAD~' "${_target_dir}"
136 git commit \
137 --signoff \
138 --message "kernel/${platform_name}: Restore kernel files for v${source_version}" \
139 --message "$(printf "This is an automatically generated commit which aids following Kernel patch history,\nas git will see the move and copy as a rename thus defeating the purpose.\n\nSee: https://lists.openwrt.org/pipermail/openwrt-devel/2023-October/041673.html\nfor the original discussion.")"
140 git switch "${initial_branch:?Unable to switch back to original branch. Quitting.}"
141 GIT_EDITOR=true git merge --no-ff '__openwrt_kernel_files_mover'
142 git branch --delete '__openwrt_kernel_files_mover'
143
144 echo "Original commitish was '${initial_commitish}'."
145 echo 'Kernel bump complete. Remember to use `git log --follow`.'
146 }
147
148 check_requirements()
149 {
150 for _cmd in ${REQUIRED_COMMANDS}; do
151 if ! _test_result="$(command -V "${_cmd}")"; then
152 _test_result_fail="${_test_result_fail:-}${_test_result}\n"
153 else
154 _test_result_pass="${_test_result_pass:-}${_test_result}\n"
155 fi
156 done
157
158 echo 'Available commands:'
159 # As the results contain \n, we expect these to be interpreted.
160 # shellcheck disable=SC2059
161 printf "${_test_result_pass:-none\n}"
162 echo
163 echo 'Missing commands:'
164 # shellcheck disable=SC2059
165 printf "${_test_result_fail:-none\n}"
166 echo
167
168 if [ -n "${_test_result_fail:-}" ]; then
169 echo 'Command test failed, missing programs.'
170 test_failed=1
171 fi
172 }
173
174 main()
175 {
176 while getopts 'hp:s:t:' _options; do
177 case "${_options}" in
178 'h')
179 usage
180 exit 0
181 ;;
182 'p')
183 platform_name="${OPTARG}"
184 ;;
185 's')
186 source_version="${OPTARG}"
187 ;;
188 't')
189 target_version="${OPTARG}"
190 ;;
191 ':')
192 e_err "Option -${OPTARG} requires an argument."
193 exit 1
194 ;;
195 *)
196 e_err "Invalid option: -${OPTARG}"
197 exit 1
198 ;;
199 esac
200 done
201 shift "$((OPTIND - 1))"
202
203 platform_name="${platform_name:-${PLATFORM_NAME:-}}"
204 source_version="${source_version:-${SOURCE_VERSION:-}}"
205 target_version="${target_version:-${TARGET_VERSION:-}}"
206
207 if [ -z "${source_version:-}" ] || [ -z "${target_version:-}" ]; then
208 e_err "Source (${source_version:-missing source version}) and target (${target_version:-missing target version}) versions need to be defined."
209 echo
210 usage
211 exit 1
212 fi
213
214 check_requirements
215
216 init
217 bump_kernel
218 cleanup
219 }
220
221 main "${@}"
222
223 exit 0